<?php

namespace ebaySdk\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for BidderDetailArrayType ArrayType
 * Meta information extracted from the WSDL
 * - documentation: This type is deprecated.
 * @subpackage Arrays
 */
class BidderDetailArrayType extends AbstractStructArrayBase
{
    /**
     * The BidderDetail
     * Meta information extracted from the WSDL
     * - documentation: This field is deprecated.
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \ebaySdk\StructType\BidderDetailType[]
     */
    public $BidderDetail;
    /**
     * Constructor method for BidderDetailArrayType
     * @uses BidderDetailArrayType::setBidderDetail()
     * @param \ebaySdk\StructType\BidderDetailType[] $bidderDetail
     */
    public function __construct(array $bidderDetail = array())
    {
        $this
            ->setBidderDetail($bidderDetail);
    }
    /**
     * Get BidderDetail value
     * @return \ebaySdk\StructType\BidderDetailType[]|null
     */
    public function getBidderDetail()
    {
        return $this->BidderDetail;
    }
    /**
     * This method is responsible for validating the values passed to the setBidderDetail method
     * This method is willingly generated in order to preserve the one-line inline validation within the setBidderDetail method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateBidderDetailForArrayConstraintsFromSetBidderDetail(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $bidderDetailArrayTypeBidderDetailItem) {
            // validation for constraint: itemType
            if (!$bidderDetailArrayTypeBidderDetailItem instanceof \ebaySdk\StructType\BidderDetailType) {
                $invalidValues[] = is_object($bidderDetailArrayTypeBidderDetailItem) ? get_class($bidderDetailArrayTypeBidderDetailItem) : sprintf('%s(%s)', gettype($bidderDetailArrayTypeBidderDetailItem), var_export($bidderDetailArrayTypeBidderDetailItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The BidderDetail property can only contain items of type \ebaySdk\StructType\BidderDetailType, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set BidderDetail value
     * @throws \InvalidArgumentException
     * @param \ebaySdk\StructType\BidderDetailType[] $bidderDetail
     * @return \ebaySdk\ArrayType\BidderDetailArrayType
     */
    public function setBidderDetail(array $bidderDetail = array())
    {
        // validation for constraint: array
        if ('' !== ($bidderDetailArrayErrorMessage = self::validateBidderDetailForArrayConstraintsFromSetBidderDetail($bidderDetail))) {
            throw new \InvalidArgumentException($bidderDetailArrayErrorMessage, __LINE__);
        }
        $this->BidderDetail = $bidderDetail;
        return $this;
    }
    /**
     * Add item to BidderDetail value
     * @throws \InvalidArgumentException
     * @param \ebaySdk\StructType\BidderDetailType $item
     * @return \ebaySdk\ArrayType\BidderDetailArrayType
     */
    public function addToBidderDetail(\ebaySdk\StructType\BidderDetailType $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \ebaySdk\StructType\BidderDetailType) {
            throw new \InvalidArgumentException(sprintf('The BidderDetail property can only contain items of type \ebaySdk\StructType\BidderDetailType, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->BidderDetail[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \ebaySdk\StructType\BidderDetailType|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \ebaySdk\StructType\BidderDetailType|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \ebaySdk\StructType\BidderDetailType|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \ebaySdk\StructType\BidderDetailType|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \ebaySdk\StructType\BidderDetailType|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string BidderDetail
     */
    public function getAttributeName()
    {
        return 'BidderDetail';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ebaySdk\ArrayType\BidderDetailArrayType
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
